var App = Ember.Application.create();

App.Router.map(function(){
	this.resource("page", function(){
		this.route("about");
		this.route("contact");
	});
	this.route("post");
	this.route("folder", {path: "/folder/:id_folder"});
});

App.PageAboutView = Ember.View.extend({
	didInsertElement: function(){
		console.log("PageAboutView");
	}
});

App.PageContactView = Ember.View.extend({
	didInsertElement: function(){
		console.log("PageContactView");
	}
});


App.PageIndexView = Ember.View.extend({
	didInsertElement: function(){
		console.log("PageIndexView");
	}
});

App.AddFolderComponent = Ember.TextField.extend({
	insertNewline: function(){
		var value = this.get("value");
		this.triggerAction({
			action: "pushFolder",
			target: this.get('parentView.controller'),
			actionContext: value
		});
	}
});

Ember.Handlebars.registerHelper("add-folder-on-enter", function(options){
	return Ember.Handlebars.helpers.view.call(this, App.AddFolderComponent, options);
});

App.EditableComponent = Ember.Component.extend({
	layout: Ember.computed(function(){
		return Ember.Handlebars.compile(
			'{{#if isEditable}}'+
				'{{view App.EditField value=value}}'+
			'{{else}}'+
				'{{value}}'+	
			'{{/if}}'
		);
	}),

	isEditable: false,
	value: null,
	cache: null,

	click: function(){
		this.set('isEditable', true);
		this.set('cache', this.get('value'));
	},

	focusOut: function(){
		this.set('value', this.get('cache'));
		this.set('isEditable', false);
	},

	keyDown: function(event){
        switch( event.which ) {
            case 27: 
				this.focusOut();
                break;
            case 13:                                
                this.set('cache', this.get('value'));                                                 
                this.set('isEditable', false);
                break;
        }
    }
});

App.EditField = Ember.TextField.extend({
	didInsertElement: function(){
		this.$().focus();
	}
});

Ember.Handlebars.registerHelper("editable", function(path, options){
	options.hash.valueBinding = path;
	return Ember.Handlebars.helpers.view.call(this, App.EditableComponent, options);
});