App.BookmarkObject = Ember.Object.extend({
	id_folder: -1,
	name: "",
	url: ""
});

var bookmarks = [
	App.BookmarkObject.create({id_folder: 1, name: "Ember.js", url: "www.emberjs.com"}),
	App.BookmarkObject.create({id_folder: 1, name: "Angular.js", url: "www.angularjs.com"}),
	App.BookmarkObject.create({id_folder: 2, name: "Symfony", url: "www.symfony.com"})
];

App.FolderRoute = Ember.Route.extend({
	model: function(param){
		var id_folder = Number(param.id_folder),
			model = {
				id_folder: id_folder,
				bookmarks: bookmarks.filterBy("id_folder", id_folder)
			};
		return model;
	},
	setupController: function(controller, model){
		controller.set('model', model.bookmarks);
		controller.setupForm(model.id_folder);
	}
});

App.FolderController = Ember.ArrayController.extend({
	model: [],

	form: {},

	addBookmark: function(bookmark){
		if(!bookmark.get('url')){
			alert("Please enter URL!");
			return false;
		}
		if(!bookmark.get('name')){
			bookmark.set('name', bookmark.get('url'));
		}

		bookmarks.pushObject(bookmark);
		this.get('model').pushObject(bookmark);
		this.setupForm(bookmark.id_folder);
		return true;
	},

	setupForm: function(id_folder){
		var form = App.BookmarkObject.create({id_folder: id_folder});
		this.set('form', form);
	},

	actions: {
		pushBookmark: function(bookmark){
			this.addBookmark(bookmark);
		},

		deleteBookmark: function(bookmark){
			bookmarks.removeObject(bookmark);
			this.get('model').removeObject(bookmark);
		}
	}

});