App.FolderTreeObject = Ember.Object.extend({
	id: -1,
	name: ""
});

var folders = [
	App.FolderTreeObject.create({id: 1, name: "Javascript"}),
	App.FolderTreeObject.create({id: 2, name: "PHP"}),
	App.FolderTreeObject.create({id: 3, name: "C#"}),
	App.FolderTreeObject.create({id: 4, name: "Java"}),
];

App.FolderTreeView = Ember.View.extend({
	willInsertElement: function(){
		var controller = this.get('controller');
		controller.set('model', folders);
	}
});

App.FolderTreeController = Ember.ArrayController.extend({
	model: [],
	folderName: "",

	addFolder: function(folderName){
		var folder, modelLength;
		if(!folderName){
			alert("Please insert folder name!");
			return false;
		}
		if(this.get('model').findBy("name", folderName)){
			alert("Please enter another folder name!");
			return false;
		}

		modelLength = this.get('model.length');
		folder = App.FolderTreeObject.create({
			id: (modelLength + 1),
			name: folderName
		});
		this.get('model').pushObject(folder);
		this.set('folderName', "");
		this.transitionToRoute("folder", folder.get('id'));
		return true;
	},

	actions: {
		pushFolder: function(folderName){
			this.addFolder(folderName);
		}
	}
});